
def frame_count():
    """Count the number of frames in the backtrace"""
    c = 0
    f = gdb.newest_frame()
    while f is not None:
        c = c + 1
        f = f.older()
    return c

def factorial_hook():
    """Called whenever Try.Factorial is reached"""
    max_number_of_frames = 100
    fc = frame_count()
    if fc <= max_number_of_frames:
        gdb.execute("continue")
    else:
        print ""
        print ("warning: more than %d frames in backtrace."
               % max_number_of_frames)
        print "         To ease the investigation, the selected frame will be"
        print "         the first call to factorial."
        print ""
        f = gdb.newest_frame()
        while f is not None and f.name() == "try.factorial":
            gdb.Frame.select(f)
            f = f.older()
        # Finally, show the frame that this loop selected; it is the first
        # call to factorial
        gdb.execute("frame")
